<?php
/**
* @package TLE2
* @subpackage SecurityPlugins
*/
/**
* In order for this plugin to work, the php_ldap extension must be installed.
* @param string $username Username to authenticate
* @param string $password Password to use to authenticate
*/
	function coreLdap($username, $password, $authType) {

	if ($authType!='coreLdap') return false;

	if (1) {

		// using ldap bind *** NOTE the uname *****
		$ldaprdn  = 'uid='.$username.',ou=People,o=anu.edu.au';    // ldap rdn or dn
		$ldappass = $password;  // associated password

		// connect to ldap server
		$ldapconn = ldap_connect("ldap.anu.edu.au")
		   or die("Could not connect to LDAP server.");

		if (ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, 3)) {
			echo "Using LDAPv3";
		} else {
			echo "Failed to set protocol version to 3";
		}

		if ($ldapconn) {

			// binding to ldap server
			$ldapbind = ldap_bind($ldapconn, $ldaprdn, $ldappass);

			// verify binding
			if ($ldapbind) {
				$sr=ldap_search($ldapconn, "ou=People,o=anu.edu.au", "uid=u4056418");  
				$info = ldap_get_entries($ldapconn, $sr);

				return $info[0]["displayname"][0];
			} else {
				return false;
			}

		}

	} // if

	}// function

	if (is_null($_PLUGINS)) {
		echo "PH is null";
	}
	$_PLUGINS->registerFunction('onAuthenticateUser','LdapAuthentication','coreLdap');

	/**
	* Would handle any thing that has to be done to clear up a LDAP authentication.
	*/
	function coreLdapLogout($userid) {
		return true;
	}
	$_PLUGINS->registerFunction('onUserLogout','LdapAuthentication','coreLdapLogout');
?>
